/*This is the main plushie script, this script should NOT be modified and should not HAVE to be modified.
if you absolutely need to repack this, you must repack it with all comments and credits included*/

--Script made by Mari0shi06
--Help given by LJ Sonic and Monster Iestyn
--Original Yakko Plush pk3 by Fluffy Smiles the Fox
--Original Rollangle code by Speccy

rawset(_G, "M06_Plushie", {}) --Set the table for the functions to go in

local MP = M06_Plushie --Shortcut so I don't have to type M06_Plushie everytime
MP.PlushieTable = {}

addHook("NetVars", function(net)
	MP = net($)
	MP.PlushieTable = net($)
end)


COM_AddCommand("plushie", function(player, arg)
	if not arg
		CONS_Printf(player, "plushie <plushie name>, change your plushie skin. Valid plushie names are")
		for name, stuff in pairs(M06_Plushie.PlushieTable) do
			CONS_Printf(player, name)
		end
		return
	end
	if MP.PlushieTable[arg] == nil
		CONS_Printf(player, "This is not a valid plushie name")
		return
	end
	player.plushie = arg
	if player.mo.valid
		if player.mo.skin == "plushie"
			player.skincolor = MP.PlushieTable[player.plushie].prefcolor
			player.mo.color = MP.PlushieTable[player.plushie].prefcolor
		end
	end
	if MP.PlushieTable[player.plushie].realname != nil
		CONS_Printf(player, "Your plushie skin is now "..MP.PlushieTable[player.plushie].realname)
	else
		CONS_Printf(player, "Your plushie skin is now "..player.plushie)
	end
end)

local function PlushieModule(player)
	if player and player.mo.valid
		if player.plushie == nil then player.mo.color = SKINCOLOR_GOLD player.plushie = "yakko" end
		if (player.mo.spritexscale == (FRACUNIT/MP.PlushieTable[player.plushie].highresscale)) and (player.mo.spriteyscale == (FRACUNIT/MP.PlushieTable[player.plushie].highresscale)) and player.mo.skin != "plushie"
			player.mo.spritexscale = FRACUNIT
			player.mo.spriteyscale = FRACUNIT
		end
		if player.mo.skin == "plushie"
			if MP.PlushieTable[player.plushie].spritename ~= nil
				player.mo.sprite = MP.PlushieTable[player.plushie].spritename
			else
				player.mo.sprite = SPR_UNKN
			end
			if MP.PlushieTable[player.plushie].spinroll == true
				if (not P_IsObjectOnGround(player.mo)) and not (player.powers[pw_carry] == CR_BRAKGOOP) and not (player.powers[pw_carry] == CR_MINECART) and not (player.powers[pw_carry] == CR_ROLLOUT) and not (player.powers[pw_carry] == CR_PTERABYTE) and not (player.powers[pw_carry] == CR_PLAYER)//When in the air, speeEEEEn and be able to attack
					player.mo.rollangle = (player.mo.rollangle + ANG15)
					player.pflags = $ |PF_JUMPED
				elseif player.pflags & PF_SPINNING	//Keep spinning state if on ground only
					player.mo.rollangle = (player.mo.rollangle + ANG15)
				else
					player.mo.rollangle = 0 //Otherwise act normal
				end
			end
			if MP.PlushieTable[player.plushie].ishighres == true
				player.charflags = $ |SF_HIRES
				if MP.PlushieTable[player.plushie].highresscale
					player.mo.spritexscale = FRACUNIT/MP.PlushieTable[player.plushie].highresscale
					player.mo.spriteyscale = FRACUNIT/MP.PlushieTable[player.plushie].highresscale
				else
					error("If you're going to set ishighres to true, you must provide a highresscale.",2)
				end
			else
				if player.charflags & SF_HIRES
					player.charflags = $ & ~SF_HIRES
				end
			end
			if MP.PlushieTable[player.plushie].charability != nil
				if player.charability ~= MP.PlushieTable[player.plushie].charability then player.charability = MP.PlushieTable[player.plushie].charability end
			end
			if MP.PlushieTable[player.plushie].actionspd != nil
				if player.actionspd ~= MP.PlushieTable[player.plushie].actionspd then player.actionspd = FRACUNIT*MP.PlushieTable[player.plushie].actionspd end
			end
			if MP.PlushieTable[player.plushie].normalspeed != nil
				if player.normalspeed ~= MP.PlushieTable[player.plushie].normalspeed then player.normalspeed = FRACUNIT*MP.PlushieTable[player.plushie].normalspeed end
			end
			if MP.PlushieTable[player.plushie].charflags != nil
				if player.charflags ~= MP.PlushieTable[player.plushie].charflags then player.charflags = MP.PlushieTable[player.plushie].charflags end
			end
			if MP.PlushieTable[player.plushie].charability2 != nil
				if player.charability2 ~= MP.PlushieTable[player.plushie].charability2 then player.charability2 = MP.PlushieTable[player.plushie].charability2 end
			end
			if MP.PlushieTable[player.plushie].mindash != nil
				if player.mindash ~= MP.PlushieTable[player.plushie].mindash then player.mindash = FRACUNIT*MP.PlushieTable[player.plushie].mindash end
			end
			if MP.PlushieTable[player.plushie].maxdash != nil
				if player.maxdash ~= MP.PlushieTable[player.plushie].maxdash then player.maxdash = FRACUNIT*MP.PlushieTable[player.plushie].maxdash end
			end
			if MP.PlushieTable[player.plushie].thrustfactor != nil
				if player.thrustfactor ~= MP.PlushieTable[player.plushie].thrustfactor then player.thrustfactor = FRACUNIT*MP.PlushieTable[player.plushie].thrustfactor end
			end
			if MP.PlushieTable[player.plushie].accelstart != nil
				if player.accelstart ~= MP.PlushieTable[player.plushie].accelstart then player.accelstart = FRACUNIT*MP.PlushieTable[player.plushie].accelstart end
			end
			if MP.PlushieTable[player.plushie].acceleration != nil
				if player.acceleration ~= MP.PlushieTable[player.plushie].acceleration then player.acceleration = FRACUNIT*MP.PlushieTable[player.plushie].acceleration end
			end
			if MP.PlushieTable[player.plushie].thokitem != nil
				if player.thokitem ~= MP.PlushieTable[player.plushie].thokitem then player.thokitem = MP.PlushieTable[player.plushie].thokitem end
			end
			if MP.PlushieTable[player.plushie].revitem != nil
				if player.revitem ~= MP.PlushieTable[player.plushie].revitem then player.revitem = MP.PlushieTable[player.plushie].revitem end
			end
			if MP.PlushieTable[player.plushie].spinitem != nil
				if player.spinitem ~= MP.PlushieTable[player.plushie].spinitem then player.spinitem = MP.PlushieTable[player.plushie].spinitem end
			end
			if MP.PlushieTable[player.plushie].supercolor
				if player.yoursupercolor == (0 or nil)
					if player.powers[pw_super]
						player.mo.color = (MP.PlushieTable[player.plushie].supercolor + abs( ( (player.powers[pw_super] >> 1) % 9) - 4))
					end
				end
			end
		end
	end
end

addHook("PostThinkFrame", do for player in players.iterate PlushieModule(player) end end)

addHook("MobjThinker", function(mo)
	if mo.valid
		if (mo.target and mo.target.valid)
			if mo.target.player and mo.target.skin == "plushie"	
				mo.spritexscale = mo.target.spritexscale
				mo.spriteyscale = mo.target.spriteyscale
			end
		end
	end
end, MT_GHOST)